public class Primes {
	
	public static void main(String[] args) {
		System.out.println(getPrimeNaive(8000));
		System.out.println(getPrimeDP(8000));
	}
	
	public static long getPrimeNaive(int n) {
		if(n <= 0) {
			return 2;
		} else {
			long p = getPrimeNaive(n - 1);
			do {
				p++;
			} while(!isPrimeNaive(p));
			
			return p;
		}
	}
	
	public static boolean isPrimeNaive(long p) {
		for(long i = 2; i*i <= p; i++) {
			if(p % i == 0) {
				return false;
			}
		}
		return true;
	}
	
	public static long getPrimeDP(int n) {
		long[] primes = new long[n + 1];
		primes[0] = 2;
		
		return getPrimeDPHelper(n, primes) ;	
	}
	
	public static long getPrimeDPHelper(int n, long primes[]) {
		if(n <= 0)
			return 2;
		
		if(primes[n] == 0) {
			long p = getPrimeDPHelper(n - 1, primes);
			
			do {
				p++;
			} while(!isPrimeDP(p, primes));
			
			primes[n] = p;
		}
		
		return primes[n];
	}
	
	public static boolean isPrimeDP(long p, long primes[]) {
		for(int i = 0; primes[i] * primes[i] <= p; i++) {
			if(primes[i] != 0 && p % primes[i] == 0)
				return false;
		}
		
		return true;
	}

}
